# Tic Tac Toe Game

A simple Tic Tac Toe game built using C++.

## Documentation

The documentation for this project is generated using [Doxygen](https://www.doxygen.nl/). The documentation can be found in the `docs` folder. Please note that the `html` folder needs to be downloaded for the Doxygen documentation to be opened properly. To view the documentation, navigate to the `docs/html` folder and open the `index.html` file in your web browser.

## Mini Guide to Doxygen

### Downloads
1. Download and install Doxygen from [here](https://www.doxygen.nl/download.html).

### Create Config File
1. After downloading open a terminal or command prompt.
2. Navigate to your project directory.
3. Run the command: `doxygen -g Doxyfile` to generate a default configuration file named `Doxyfile`.

### Generate Documentation
1. Open the `Doxyfile` in a text editor. For example, you can use the command `code Doxyfile` to open it in VS Code.
2. Set the `INPUT` field to the directories containing your source code.
3. Set the `OUTPUT_DIRECTORY` field to the desired output directory (e.g., `docs`).
4. Save the `Doxyfile`.
5. Run the command: `doxygen Doxyfile` to generate the documentation.

The generated documentation will be available in the specified output directory. Note that it is recommended to adjust additional variables inside the `Doxyfile` to match the desired level of documentation for your project, such as `RECURSIVE`, `EXTRACT_ALL`, and `EXTRACT_PRIVATE`.

